package com.expvintl.mctools;

import com.expvintl.mctools.commands.*;
import com.expvintl.mctools.utils.Utils;
import com.mojang.brigadier.CommandDispatcher;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.client.command.v2.ClientCommandRegistrationCallback;
import net.fabricmc.fabric.api.client.command.v2.FabricClientCommandSource;
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback;
import net.minecraft.class_1799;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_332;
import net.minecraft.class_7157;
import net.minecraft.class_746;
import net.minecraft.class_8012;
import net.minecraft.class_9779;


public class MCToolsClient implements ClientModInitializer {
    private static int infoY=1;
    @Override
    public void onInitializeClient() {

        //初始化命令注册回调
        ClientCommandRegistrationCallback.EVENT.register(MCToolsClient::registerCommands);
        HudRenderCallback.EVENT.register(MCToolsClient::drawHUD);

    }
    private static String gameDayToRealTimeFormat(long gameDays) {
        // 游戏 1 小时等于 20 分钟
        long totalMinutes = gameDays * 20;

        long days = totalMinutes / (60 * 24); // 计算天数
        long remainingMinutesAfterDays = totalMinutes % (60 * 24);

        long hours = remainingMinutesAfterDays / 60; // 计算小时数
        long minutes = remainingMinutesAfterDays % 60; // 计算剩余分钟数

        StringBuilder timeString = new StringBuilder();

        if (days > 0) {
            timeString.append(days).append(" 天");
        }
        if (hours > 0) {
            if (!timeString.isEmpty()) {
                timeString.append(" ");
            }
            timeString.append(hours).append(" 小时");
        }
        if (minutes > 0 || timeString.isEmpty()) {
            if (!timeString.isEmpty()) {
                timeString.append(" ");
            }
            timeString.append(minutes).append(" 分钟");
        }

        return timeString.toString();
    }
    private static void drawHUD(class_332 drawContext, class_9779 v) {
        class_310 mc=class_310.method_1551();
        //跳过调试
        if(mc.method_53526().method_53536()) return;

        if(mc.field_1687!=null&&mc.field_1724!=null) {
            infoY=1;
            int selfPing=0;
            class_746 p=mc.field_1724;
            if(mc.method_1562()!=null&&mc.method_1562().method_2871(mc.field_1724.method_7334().getId())!=null) {
                selfPing=mc.method_1562().method_2871(mc.field_1724.method_7334().getId()).method_2959();
            }
            class_243 playerPos=p.method_19538();
            AddText(drawContext,String.format("%d FPS",mc.method_47599()));
            AddText(drawContext,String.format("Ping: %d 毫秒",selfPing));
            AddText(drawContext,String.format("亮度:%d",mc.field_1687.method_22339(p.method_24515())));
            AddText(drawContext,String.format("当前维度:%s", Utils.getCurrentDimensionName()));
            AddText(drawContext,String.format("当前群系:%s",Utils.getCurrentBiomeName()));
            if(Utils.getCurrentDimensionName().equals("下界")){
                AddText(drawContext,String.format("X:%.2f Y:%.2f Z:%.2f (主世界 X:%.2f Z:%.2f)",playerPos.field_1352,playerPos.field_1351,playerPos.field_1350,playerPos.field_1352*8,playerPos.field_1350*8));
            }else if(Utils.getCurrentDimensionName().equals("主世界")){
                AddText(drawContext,String.format("X:%.2f Y:%.2f Z:%.2f (下界 X:%.2f Z:%.2f)",playerPos.field_1352,playerPos.field_1351,playerPos.field_1350,playerPos.field_1352/8,playerPos.field_1350/8));
            }else{
                AddText(drawContext,String.format("X:%.2f Y:%.2f Z:%.2f",playerPos.field_1352,playerPos.field_1351,playerPos.field_1350));
            }
            AddText(drawContext,String.format("世界时间: %d天 (%s)",mc.field_1687.method_8532()/24000,gameDayToRealTimeFormat(mc.field_1687.method_8532()/24000)));
            AddText(drawContext,String.format("当前区块: [%d,%d]",mc.field_1724.method_31476().field_9181,mc.field_1724.method_31476().field_9180));
            AddText(drawContext,String.format("本地难度:%.2f",mc.field_1687.method_8404(mc.field_1724.method_24515()).method_5457()));
            class_1799 currentItem=p.method_31548().method_7391();
            if(currentItem!=null&&currentItem.method_7963()){
                AddText(drawContext,String.format("耐久度:%d/%d",currentItem.method_7936()-currentItem.method_7919(),currentItem.method_7936()));
            }
        }
    }
    private static void AddText(class_332 drawContext,String text){
        class_327 renderer=class_310.method_1551().field_1772;
        drawContext.method_51433(renderer,text,0,infoY,class_8012.field_42973,false);
        infoY+=10;
    }
    private static void registerCommands(CommandDispatcher<FabricClientCommandSource> dispatcher, class_7157 registryAccess) {
        //注册命令
        CFullbirghtCommand.register(dispatcher);
        CAutoRespawnCommand.register(dispatcher);
        CSafeWalkCommand.register(dispatcher);
        CAutoFishCommand.register(dispatcher);
        CAutoToolCommand.register(dispatcher);
        CQServerPluginsCommand.register(dispatcher);
        CNoFallPacketCommand.register(dispatcher);
        CFindBlockCommand.register(dispatcher);
        CFastDropCommand.register(dispatcher);
    }
}
