package com.expvintl.mctools.commands;

import com.expvintl.mctools.Globals;
import com.expvintl.mctools.events.MCEventBus;
import com.expvintl.mctools.events.player.PlayerAttackBlockEvent;
import com.expvintl.mctools.events.player.PlayerAttackEntityEvent;
import com.expvintl.mctools.events.player.PlayerBreakBlockEvent;
import com.expvintl.mctools.mixin.interfaces.ClientPlayerInteractionManagerAccessor;
import com.expvintl.mctools.utils.CommandUtils;
import com.expvintl.mctools.utils.Utils;
import com.google.common.eventbus.Subscribe;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.arguments.BoolArgumentType;
import com.mojang.brigadier.context.CommandContext;
import net.fabricmc.fabric.api.client.command.v2.FabricClientCommandSource;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1820;
import net.minecraft.class_1829;
import net.minecraft.class_1831;
import net.minecraft.class_1893;
import net.minecraft.class_2202;
import net.minecraft.class_2211;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_9334;
import net.minecraft.item.*;

import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.argument;
import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.literal;

public class CAutoToolCommand {
    private static final CAutoToolCommand INSTANCE=new CAutoToolCommand();
    private int lastSlot=-1;
    public static void register(CommandDispatcher<FabricClientCommandSource> dispatcher){
        MCEventBus.INSTANCE.register(INSTANCE);
        CommandUtils.CreateStatusCommand("cautotool",Globals.autoTool,dispatcher);
        dispatcher.register(literal("cautotool").then(argument("开关", BoolArgumentType.bool()).executes(CAutoToolCommand::execute)));
    }

    private static int execute(CommandContext<FabricClientCommandSource> context) {
        Globals.autoTool.set(context.getArgument("开关", Boolean.class));
        if(Globals.autoTool.get()){
            context.getSource().getPlayer().method_43496(class_2561.method_43470("已启用智能工具!"));
        }else{
            context.getSource().getPlayer().method_43496(class_2561.method_43470("已禁用智能工具!"));
        }
        return Command.SINGLE_SUCCESS;
    }
    @Subscribe
    private void onBreakBlock(PlayerBreakBlockEvent event){
        if(!Globals.autoTool.get()) return;
        class_310 mc=class_310.method_1551();
        if (mc.field_1687 == null||mc.field_1724==null) return;
        if (lastSlot!=-1){
            //破坏方块后切换回去
            mc.field_1724.method_31548().field_7545=lastSlot;
            lastSlot=-1;
        }
    }
    @Subscribe
    private void onAttackEntity(PlayerAttackEntityEvent event){
        if(!Globals.autoTool.get()) return;
        if(event.target.method_16914()) return;
        //不对玩家使用
        if(event.target.method_31747()) return;
        float bestScore=-1;
        int slot=-1;
        for(int i=0;i<9;i++) {
            float score=getWeaponScore(event.player,event.target,i);
            if(score<0) continue;
            //选出最好分数的工具
            if(score>bestScore){
                bestScore=score;
                slot=i;
            }
        }
        if(slot==-1) return;
        class_1799 currentItem = event.player.method_31548().method_5438(slot);
        //低耐久测试
        if(!lowDurability(currentItem)) {
            //切换过去
            event.player.method_31548().field_7545 = slot;
            class_310 mc=class_310.method_1551();
            if(mc.field_1761!=null) {
                ((ClientPlayerInteractionManagerAccessor) mc.field_1761).syncSelectedSlot();
            }
        }
    }
    @Subscribe
    private void onAttackBlock(PlayerAttackBlockEvent event){
        if(!Globals.autoTool.get()) return;
        //自动工具
        class_310 mc=class_310.method_1551();
        if (mc.field_1687 == null||mc.field_1724==null) return;
        class_2680 state= mc.field_1687.method_8320(event.blockPos);
        //跳过不可破坏
        if(state.method_26214(mc.field_1687, event.blockPos) < 0) return;
        //统计最好的挖掘分数
        float bestScore=-1;
        //工具槽
        int slot=-1;
        //遍历每一个物品槽
        for(int i=0;i<9;i++){
            class_1799 item = mc.field_1724.method_31548().method_5438(i);
            float score=getScore(item,state);
            if(score<0) continue;
            //选出最好分数的工具
            if(score>bestScore){
                bestScore=score;
                slot=i;
            }
        }
        if(slot==-1) return;
        class_1799 currentItem = mc.field_1724.method_31548().method_5438(slot);
        //确定已经选择好了工具就切换
        if(!lowDurability(currentItem)) {
            //记住上一次的槽方便恢复
            lastSlot=mc.field_1724.method_31548().field_7545;
            //切换过去
            mc.field_1724.method_31548().field_7545 = slot;
            if(mc.field_1761!=null) {
                ((ClientPlayerInteractionManagerAccessor) mc.field_1761).syncSelectedSlot();
            }
        }
    }
    public float getScore(class_1799 item, class_2680 state){
        float score=0;
        //Is Tool!!
        if(item.method_7909() instanceof class_1831 || item.method_7909() instanceof class_1820){
            //根据挖掘速度提升评分
            score+=item.method_7924(state)*30;
            //附魔加分
            //耐久
            score+= Utils.GetEnchantLevel(class_1893.field_9119, item);
            //效率
            score+=Utils.GetEnchantLevel(class_1893.field_9131,item);
            //经验修补(此项最优先)
            score+=Utils.GetEnchantLevel(class_1893.field_9101,item);
            if (item.method_7909() instanceof class_1829 item1 && (state.method_26204() instanceof class_2211|| state.method_26204() instanceof class_2202))
                //根据挖掘等级加分
                score += 90 + (item1.method_57347().method_57829(class_9334.field_50077).method_58425(state) * 10);
        }
        return score;
    }
    public float getWeaponScore(class_1657 player,class_1297 target,int slot) {
        float damageScore = 0;
        class_1799 item = player.method_31548().method_5438(slot);
        //剑优先
        if(item.method_7909() instanceof class_1829) damageScore+=10;
        //使用所有工具组
        if (item.method_7909() instanceof class_1831 tool) {
            damageScore += tool.method_8022().method_8028();
            //锋利加分
            damageScore += Utils.GetEnchantLevel(class_1893.field_9118, item) * 2;
            //精修
            damageScore+=Utils.GetEnchantLevel(class_1893.field_9101,item);
            //火焰附加
            damageScore+=Utils.GetEnchantLevel(class_1893.field_9124,item)*3;
            //击退
            damageScore+=Utils.GetEnchantLevel(class_1893.field_9121,item)*2;
        }
        return damageScore;
    }
    //停用低耐久度
    private boolean lowDurability(class_1799 itemStack) {
        return  (itemStack.method_7936() - itemStack.method_7919()) < (itemStack.method_7936() * 10 / 100);
    }
}
